﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BugInfragistics
{

    public class StoppableEventArgs : EventArgs
    {
        public StoppableEventArgs()
        {
            this.Stop = false;
        }

        public bool Stop
        {
            get;
            set;
        }
    }

    public class ValueChangingEventArgs<T> : StoppableEventArgs
    {
        public T OldValue
        {
            get;
            private set;
        }

        public T NewValue
        {
            get;
            set;
        }

        public ValueChangingEventArgs(T oldValue, T newValue)
            : base()
        {
            this.NewValue = newValue;
            this.OldValue = oldValue;
        }
    }

    public class ValueChangedEventArgs<T> : EventArgs
    {
        public T OldValue
        {
            get;
            private set;
        }

        public T NewValue
        {
            get;
            private set;
        }

        public ValueChangedEventArgs(T oldValue, T newValue)
        {
            this.NewValue = newValue;
            this.OldValue = oldValue;
        }

        public ValueChangedEventArgs(ValueChangingEventArgs<T> evtArgs)
        {
            this.NewValue = evtArgs.NewValue;
            this.OldValue = evtArgs.OldValue;
        }
    }

    public class NewValueEventArgs<T> : EventArgs
    {
        public T Value
        {
            get;
            private set;
        }
        public NewValueEventArgs(T value)
        {
            this.Value = value;
        }
    }

}
